'--------------------------   --------------------------------
Declare  SHOW_SYSTEM_VARIABLES = OFF   '    Proteus    
Declare  Optimiser_Level 0             '    
                                                                   
;--------------------------  ------------------------------------
Device = 16F876A   '  
Xtal = 20          '    20 
                                                                   
'--------------------------    ------------------------
Declare  LCD_Type ALPHA       '   -  -
Declare  LCD_DTPin  PORTB.4   '   
Declare  LCD_ENPin  PORTB.3   '   E
Declare  LCD_RSPin  PORTB.2   '   RS
Declare  LCD_Interface  4     '   
Declare  LCD_CommandUs  2000  '    
Declare  LCD_DataUs  50       '    
Declare  LCD_Lines   2        '   
                                                                   
'--------------------------   ---------------------------------
PortB_Pullups = OFF        '     PORTB
Declare  All_Digital = OFF '       

TRISA = %00001101
TRISB = %00000001
TRISC = %11111111

PORTA.5 = 0
PORTA.1 = 1
                                                                   
'--------------------------   -------------------
CMCON = %00010110   '  
CVRCON = %11000101  '    1.04                                                                      

'-------------------------- INTCON --------------------------------------------
Symbol RBIF = INTCON.0 '     PORTB.4-PORTB.7
Symbol INTF = INTCON.1 '     PORTB.0(INT)
Symbol T0IF = INTCON.2 '   TMR0
Symbol RBIE = INTCON.3 '     PORTB.4-PORTB.7
Symbol INTE = INTCON.4 '     PORTB.0(INT) 
Symbol T0IE = INTCON.5 '      TMR0
Symbol PEIE = INTCON.6 '      
Symbol GIE = INTCON.7  '    
                                                                   
'-------------------------- PIE1, PIR1 ----------------------------------------------
Symbol CMIF = PIR2.6   '     
Symbol CMIE = PIE2.6   '                                                                        

'-------------------------- T1CON ---------------------------------------------------
Symbol TMR1ON = T1CON.0     '    TMR1 
Symbol TMR1CS = T1CON.1     '      TMR1
Symbol NOT_T1SYNC = T1CON.2 '    
Symbol T1INSYNC = T1CON.2   '    
Symbol T1SYNC = T1CON.2     '    
Symbol T1OSCEN = T1CON.3    '    TMR1
Symbol T1CKPS0 = T1CON.4    '     TMR1
Symbol T1CKPS1 = T1CON.5    '     TMR1

'--------------------------  -------------------------------------------
Dim i As Dword
Dim y As Byte
Dim wq As Byte
Symbol TIMER1 = TMR1L.Word
Dim x[16] As Word
'--------------------------  TMR1   --------------------
T1CON = %00000000

'--------------------------     --------------------
CMIE = 0 '    
PEIE = 1 ' Ht                                                                    
GIE = 1  '   
TIMER1 = 0

On_Interrupt GoTo  Int_Label
GoTo  MainProgram
'-------------------------- --------------------------
Int_Label:
Context Save                                            
; If CMIF = 1 Then '   
    If CMCON.6 = 0 Then  '      , 
       TMR1ON = 0                  '  
       Inc y
        x[y-1] = TIMER1
 ;      i =  (TIMER1 * 200) / 1000  '  
 ;      If i < 80 Then x[y - 1] = 1 '   ,  80 ,   1 
 ;      If i > 80 Then x[y - 1] = 0 '   ,  80 ,   0 
      If y = 16 Then CMIE = 0     '   


    EndIf   

    If CMCON.6 = 1 Then            '      
       TIMER1 = 0        '  
       TMR1ON = 1        '  

    EndIf 
; EndIf
 wq = CMCON     '   CMCON (    CMIF)
 CMIF = 0       '     
Context Restore '    
                                                              
'--------------------------   -------------------------

MainProgram:
 If PORTC.4 = 0 Then '   
    DelayMS 250        '     
    Repeat
    Until PORTC.4 = 1  ' ,     
    DelayMS 250        '     
    Cls                '  
    i = 0              '  
    y = 0              '  
  
    Repeat
    Until CMCON.6 = 1  ' ,       

    CMIE = 1           '    
 EndIf 

 Nop
 Nop
 Nop

; Print At 1,1, Dec x[0], Dec x[1], Dec x[2], Dec x[3], Dec x[4], Dec x[5], Dec x[6], Dec x[7], Dec x[8], Dec x[9], Dec x[10], Dec x[11], Dec x[12], Dec x[13], Dec x[14], Dec x[15]
GoTo  MainProgram    '     
                                                                   
                                                                   

